#pragma once

#include <QWidget>
#include <QLabel>
#include <QDateTimeEdit>
#include <QVBoxLayout>
#include <QTimer>
#include <QLineEdit>

class RemainingTimer: public QWidget {
  Q_OBJECT
public:
  RemainingTimer() {
  	setLayout( new QVBoxLayout() );

	descLE = new QLineEdit();
	layout()->addWidget( descLE );

	destTime = new QDateTimeEdit( QDateTime::currentDateTime() );
	destTime->setDisplayFormat( "dd MMM yyyy hh:mm:ss" );
	layout()->addWidget( destTime );

	remTimeL = new QLabel();
	layout()->addWidget( remTimeL );

	QTimer *t = new QTimer( this );
	connect( t, SIGNAL(timeout()), SLOT(updateTime()) );

	updateTime();
	t->start( 1000 );
  }

  QLineEdit *descLE;
  QDateTimeEdit *destTime;
  QLabel *remTimeL;

protected slots:
  void updateTime() {
  	QDateTime currentDT = QDateTime::currentDateTime();
  	int remTime = currentDT.secsTo( destTime->dateTime() );
	if ( remTime > 0 ) {
		int h = remTime / 60 / 60;
		int m = remTime / 60 - h * 60;
		int s = remTime - (h * 60 + m) * 60; 
		remTimeL->setText( QString().sprintf("%02d:%02d:%02d", h, m, s) );
	}
	else
		remTimeL->setText( "00:00:00" );
  }
};
